Index: /NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/TOP/PISCES/SED/sedrst.F90
===================================================================
--- /NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/TOP/PISCES/SED/sedrst.F90	(revision 10344)
+++ /NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/TOP/PISCES/SED/sedrst.F90	(revision 10345)
@@ -1,4 +1,3 @@
 MODULE sedrst
-#if defined key_sed
    !!======================================================================
    !!                       *** MODULE sedrst ***
@@ -11,4 +10,9 @@
    USE sed
    USE sedarr
+   USE trc_oce, ONLY : l_offline, nn_dttrc
+   USE phycst , ONLY : rday
+   USE iom
+   USE daymod
+   USE lib_mpp         ! distribued memory computing library
 
 
@@ -18,14 +22,65 @@
 
    !! * Accessibility
+   PUBLIC sed_rst_opn       ! called by ???
    PUBLIC sed_rst_read
    PUBLIC sed_rst_wri
-
-   !! * Module variables
-   INTEGER, PUBLIC ::   numrsr, numrsw   !: logical unit for sed restart (read and write)
-   
-   
+   PUBLIC sed_rst_cal
+
    !! $Id$
 CONTAINS
 
+
+   SUBROUTINE sed_rst_opn( kt )
+      !!----------------------------------------------------------------------
+      !!                    ***  sed_rst_opn  ***
+      !!
+      !! ** purpose  :   output of sed-trc variable in a netcdf file
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt       ! number of iteration
+      !
+      CHARACTER(LEN=20)   ::   clkt     ! ocean time-step define as a character
+      CHARACTER(LEN=50)   ::   clname   ! trc output restart file name
+      CHARACTER(LEN=256)  ::   clpath   ! full path to ocean output restart file
+      !!----------------------------------------------------------------------
+      !
+      IF( l_offline ) THEN
+         IF( kt == nittrc000 ) THEN
+            lrst_sed = .FALSE.
+            IF( ln_rst_list ) THEN
+               nrst_lst = 1
+               nitrst = nstocklist( nrst_lst )
+            ELSE
+               nitrst = nitend
+            ENDIF
+         ENDIF
+         IF( .NOT. ln_rst_list .AND. MOD( kt - 1, nstock ) == 0 ) THEN
+            ! we use kt - 1 and not kt - nittrc000 to keep the same periodicity from the beginning of the experiment
+            nitrst = kt + nstock - 1                  ! define the next value of nitrst for restart writing
+            IF( nitrst > nitend )   nitrst = nitend   ! make sure we write a restart at the end of the run
+         ENDIF
+      ELSE
+         IF( kt == nittrc000 ) lrst_sed = .FALSE.
+      ENDIF
+
+      ! to get better performances with NetCDF format:
+      ! we open and define the tracer restart file one tracer time step before writing the data (-> at nitrst - 2*nn_dttrc + 1)
+      ! except if we write tracer restart files every tracer time step or if a tracer restart file was writen at nitend - 2*nn_dttrc + 1
+      IF( kt == nitrst - 2*nn_dtsed .OR. nstock == nn_dtsed .OR. ( kt == nitend - nn_dtsed .AND. .NOT. lrst_sed ) ) THEN
+         ! beware of the format used to write kt (default is i8.8, that should be large enough)
+         IF( nitrst > 1.0e9 ) THEN   ;   WRITE(clkt,*       ) nitrst
+         ELSE                        ;   WRITE(clkt,'(i8.8)') nitrst
+         ENDIF
+         ! create the file
+         IF(lwp) WRITE(numsed,*)
+         clname = TRIM(cexper)//"_"//TRIM(ADJUSTL(clkt))//"_"//TRIM(cn_sedrst_out)
+         clpath = TRIM(cn_sedrst_outdir)
+         IF( clpath(LEN_TRIM(clpath):) /= '/' ) clpath = TRIM(clpath) // '/'
+         IF(lwp) WRITE(numsed,*) &
+             '             open sed restart.output NetCDF file: ',TRIM(clpath)//clname
+         CALL iom_open( TRIM(clpath)//TRIM(clname), numrsw, ldwrt = .TRUE., kiolib = jprstlib, kdlev = jpksed )
+         lrst_sed = .TRUE.
+      ENDIF
+      !
+   END SUBROUTINE sed_rst_opn
 
    SUBROUTINE sed_rst_read 
@@ -40,74 +95,54 @@
       !!        !  06-07  (C. Ethe)  original
       !!----------------------------------------------------------------------
-      !! * Modules used
-      USE iom
 
       !! * local declarations
-      INTEGER :: ji, jk, jn 
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) :: zdta
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:  ) :: zdta1 
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:    ) :: zhipor
+      INTEGER :: ji, jj, jk, jn 
+      REAL(wp), DIMENSION(jpi,jpj,jpksed,jptrased) :: zdta
+      REAL(wp), DIMENSION(jpi,jpj,jpksed,2)        :: zdta1 
+      REAL(wp), DIMENSION(jpi,jpj,jpksed)          :: zdta2
+      REAL(wp), DIMENSION(jpoce,jpksed)            :: zhipor
       REAL(wp) :: zkt
       CHARACTER(len = 20) ::   cltra
+      CHARACTER(LEN=20)   ::   name1
       INTEGER             ::   jlibalt = jprstlib
       LOGICAL             ::   llok
       !--------------------------------------------------------------------
- 
-
-      WRITE(numsed,*) ' '      
-      WRITE(numsed,*) ' Initilization of Sediment components from restart'
-      WRITE(numsed,*) ' '
-
-      ALLOCATE( zdta(jpi,jpj,jpksed,jptrased), zdta1(jpi,jpj,jpksed,2), zhipor(jpoce,jpksed) ) 
-
-      CALL iom_open( 'restart_sed', numrsr, kiolib = jlibalt )     
-      CALL iom_get( numrsr, 'kt'     , zkt      )   ! time-step
- 
+
+      IF( ln_timing )  CALL timing_start('sed_rst_read')
+
+      IF (lwp) WRITE(numsed,*) ' '      
+      IF (lwp) WRITE(numsed,*) ' Initilization of Sediment components from restart'
+      IF (lwp) WRITE(numsed,*) ' '
+
+      zdta  = 1.
+      zdta1 = 1.
+      zdta2 = 0.
+
       DO jn = 1, jptrased
-         cltra = sedtrcd(jn)
-         CALL iom_get( numrsr, jpdom_unknown, cltra, zdta(:,:,:,jn), &
-            &          kstart=(/1,1,1/), kcount=(/jpi,jpj,jpksed/) )
-      ENDDO
-        
-
-      CALL pack_arr( jpoce, solcp(1:jpoce,1:jpksed,jsopal), &
-         &            zdta(1:jpi,1:jpj,1:jpksed,1), iarroce(1:jpoce) )
-
-      CALL pack_arr( jpoce, solcp(1:jpoce,1:jpksed,jsclay), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,2), iarroce(1:jpoce) )
-
-      CALL pack_arr( jpoce, solcp(1:jpoce,1:jpksed,jspoc), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,3), iarroce(1:jpoce) )
-
-      CALL pack_arr( jpoce, solcp(1:jpoce,1:jpksed,jscal), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,4), iarroce(1:jpoce) )
-
-      CALL pack_arr( jpoce, pwcp(1:jpoce,1:jpksed,jwsil), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,5), iarroce(1:jpoce) )
-
-
-      CALL pack_arr( jpoce, pwcp(1:jpoce,1:jpksed,jwoxy), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,6), iarroce(1:jpoce) )
-
-
-      CALL pack_arr( jpoce, pwcp(1:jpoce,1:jpksed,jwdic), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,7), iarroce(1:jpoce) )
-
-      CALL pack_arr( jpoce, pwcp(1:jpoce,1:jpksed,jwno3), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,8), iarroce(1:jpoce) )
-
-      CALL pack_arr( jpoce, pwcp(1:jpoce,1:jpksed,jwpo4), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,9), iarroce(1:jpoce) )
-
-      CALL pack_arr( jpoce, pwcp(1:jpoce,1:jpksed,jwalk), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,10), iarroce(1:jpoce) )
-
-      CALL pack_arr( jpoce, pwcp(1:jpoce,1:jpksed,jwc13), &
-         &             zdta(1:jpi,1:jpj,1:jpksed,11), iarroce(1:jpoce) )
+         cltra = TRIM(sedtrcd(jn))
+         IF( iom_varid( numrsr, TRIM(cltra) , ldstop = .FALSE. ) > 0 ) THEN
+            CALL iom_get( numrsr, jpdom_autoglo, TRIM(cltra), zdta(:,:,:,jn) )
+         ELSE
+            zdta(:,:,:,jn) = 0.0
+         ENDIF
+      ENDDO
+
+      DO jn = 1, jpsol
+         CALL pack_arr( jpoce, solcp(1:jpoce,1:jpksed,jn), &
+         &              zdta(1:jpi,1:jpj,1:jpksed,jn), iarroce(1:jpoce) )
+      END DO
+
+      DO jn = 1, jpwat
+         CALL pack_arr( jpoce, pwcp(1:jpoce,1:jpksed,jn), &
+         &              zdta(1:jpi,1:jpj,1:jpksed,jpsol+jn), iarroce(1:jpoce) )
+      END DO
 
       DO jn = 1, 2
-         cltra = seddia3d(jn)
-         CALL iom_get( numrsr, jpdom_unknown, cltra, zdta1(:,:,:,jn), &
-            &          kstart=(/1,1,1/), kcount=(/jpi,jpj,jpksed/) )
+         cltra = TRIM(seddia3d(jn))
+         IF( iom_varid( numrsr, TRIM(cltra) , ldstop = .FALSE. ) > 0 ) THEN
+            CALL iom_get( numrsr, jpdom_autoglo, TRIM(cltra), zdta1(:,:,:,jn) )
+         ELSE
+            zdta1(:,:,:,jn) = 0.0
+         ENDIF
       ENDDO
 
@@ -122,5 +157,5 @@
          ENDDO
       ENDDO
-      
+
       CALL pack_arr( jpoce, co3por(1:jpoce,1:jpksed), &
          &             zdta1(1:jpi,1:jpj,1:jpksed,2), iarroce(1:jpoce) )
@@ -131,7 +166,35 @@
       pwcp (1:jpoce,1,:) = 0.
 
-      DEALLOCATE( zdta   )
-      DEALLOCATE( zdta1  )
-      DEALLOCATE( zhipor )
+      cltra = "dbioturb"
+      IF( iom_varid( numrsr, TRIM(cltra) , ldstop = .FALSE. ) > 0 ) THEN
+         CALL iom_get( numrsr, jpdom_autoglo, TRIM(cltra), zdta2(:,:,:) )
+      ELSE
+         zdta2(:,:,:) = 0.0
+      ENDIF
+
+      CALL pack_arr( jpoce, db(1:jpoce,1:jpksed), &
+         &             zdta2(1:jpi,1:jpj,1:jpksed), iarroce(1:jpoce) )
+
+      cltra = "irrig"
+      IF( iom_varid( numrsr, TRIM(cltra) , ldstop = .FALSE. ) > 0 ) THEN
+         CALL iom_get( numrsr, jpdom_autoglo, TRIM(cltra), zdta2(:,:,:) )
+      ELSE
+         zdta2(:,:,:) = 0.0
+      ENDIF
+
+      CALL pack_arr( jpoce, irrig(1:jpoce,1:jpksed), &
+         &             zdta2(1:jpi,1:jpj,1:jpksed), iarroce(1:jpoce) )
+
+      cltra = "sedligand"
+      IF( iom_varid( numrsr, TRIM(cltra) , ldstop = .FALSE. ) > 0 ) THEN
+         CALL iom_get( numrsr, jpdom_autoglo, TRIM(cltra), zdta2(:,:,:) )
+      ELSE
+         zdta2(:,:,:) = 0.0
+      ENDIF
+
+      CALL pack_arr( jpoce, sedligand(1:jpoce,1:jpksed), &
+         &             zdta2(1:jpi,1:jpj,1:jpksed), iarroce(1:jpoce) )
+
+      IF( ln_timing )  CALL timing_stop('sed_rst_read')
      
    END SUBROUTINE sed_rst_read
@@ -147,130 +210,204 @@
       !!----------------------------------------------------------------------
       !!* Modules used
-      USE ioipsl
-      !! *Arguments
       INTEGER, INTENT(in) ::   kt       ! number of iteration
       !! * local declarations
-      INTEGER  :: ji, jk
-      INTEGER  :: ic, jc, jn, itime 
-      REAL(wp) :: zdate0
+      INTEGER  :: ji, jj, jk, jn
       REAL(wp), DIMENSION(1) ::  zinfo
-      CHARACTER(len=50) :: clname,cln
-      CHARACTER(len=20) :: cltra 
-      REAL(wp), DIMENSION(:,:) , ALLOCATABLE  :: zdta   
+      CHARACTER(len=50) :: clname
+      CHARACTER(len=20) :: cltra, name1 
+      REAL(wp), DIMENSION(jpoce,jpksed)   :: zdta   
+      REAL(wp), DIMENSION(jpi,jpj,jpksed) :: zdta2
       !! -----------------------------------------------------------------------
 
-      ALLOCATE( zdta(jpoce,jpksed) )
-
-      IF( MOD(kt,nstock) == 0 .OR. kt == nitsedend ) THEN
-         
+      IF( ln_timing )  CALL timing_start('sed_rst_wri')
+
          !! 0. initialisations
          !! ------------------
          
-         IF(lwp) WRITE(numsed,*) ' '
-         IF(lwp) WRITE(numsed,*) 'sed_rst_write : write the sediment restart file in NetCDF format ',   &
+      IF(lwp) WRITE(numsed,*) ' '
+      IF(lwp) WRITE(numsed,*) 'sed_rst_write : write the sediment restart file in NetCDF format ',   &
             'at it= ',kt
-         IF(lwp) WRITE(numsed,*) '~~~~~~~~~'
+      IF(lwp) WRITE(numsed,*) '~~~~~~~~~'
+
+
+      trcsedi(:,:,:,:)   = 0.0
+      flxsedi3d(:,:,:,:) = 0.0
+      zdta(:,:)          = 1.0
+      zdta2(:,:,:)       = 0.0
+
          
-         !! 1. WRITE in nutwrs
-         !! ------------------
-
-         ic = 1
-         DO jc = 1,16
-            IF( cexper(jc:jc) /= ' ') ic = jc
-         END DO
-         WRITE( cln,'("_",i5.5,i2.2,i2.2,"_restart.sed")') nyear, nmonth, nday
-         clname = cexper(1:ic)//cln
-         itime = 0
-         CALL ymds2ju( nyear, nmonth, nday, rdt, zdate0 )
-         zdate0 = zdate0 - adatrj   !   set calendar origin to the beginning of the experiment
-         CALL restini( 'NONE', jpi, jpj, glamt, gphit, jpksed, dz, &
-            &         clname, itime, zdate0, dtsed*nstock, numrsw, domain_id=nidom )
-         zinfo(1) = REAL( kt)
-         CALL restput( numrsw, 'kt', 1,1, 1,0, zinfo  )
-
-
-
-         ! Back to 2D geometry
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,1) , iarroce(1:jpoce), &
-            &                    solcp(1:jpoce,1:jpksed,jsopal ) )
+      !! 1. WRITE in nutwrs
+      !! ------------------
+
+      zinfo(1) = REAL( kt)
+      CALL iom_rstput( kt, nitrst, numrsw, 'kt', zinfo  )
+
+      ! Back to 2D geometry
+      DO jn = 1, jpsol
+         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,jn) , iarroce(1:jpoce), &
+         &                       solcp(1:jpoce,1:jpksed,jn ) )
+      END DO
+
+      DO jn = 1, jpwat
+         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,jpsol+jn) , iarroce(1:jpoce), &
+         &                       pwcp(1:jpoce,1:jpksed,jn  )  )
+      END DO
+      ! pH
+      DO jk = 1, jpksed
+         DO ji = 1, jpoce
+            zdta(ji,jk) = -LOG10( hipor(ji,jk) / ( densSW(ji) + rtrn ) + rtrn )
+         ENDDO
+      ENDDO
+
+      CALL unpack_arr( jpoce, flxsedi3d(1:jpi,1:jpj,1:jpksed,1)  , iarroce(1:jpoce), &
+      &                   zdta(1:jpoce,1:jpksed)  )
          
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,2) , iarroce(1:jpoce), &
-            &                    solcp(1:jpoce,1:jpksed,jsclay ) )
-         
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,3) , iarroce(1:jpoce), &
-            &                    solcp(1:jpoce,1:jpksed,jspoc  ) )
-         
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,4) , iarroce(1:jpoce), &
-            &                    solcp(1:jpoce,1:jpksed,jscal  ) )   
-         
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,5) , iarroce(1:jpoce), &
-            &                    pwcp(1:jpoce,1:jpksed,jwsil  )  )
-         
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,6)  , iarroce(1:jpoce), &
-            &                    pwcp(1:jpoce,1:jpksed,jwoxy  ) )
-         
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,7)  , iarroce(1:jpoce), &
-            &                    pwcp(1:jpoce,1:jpksed,jwdic  ) )
-         
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,8)  , iarroce(1:jpoce), &
-            &                    pwcp(1:jpoce,1:jpksed,jwno3  ) )
-         
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,9)  , iarroce(1:jpoce), &
-            &                    pwcp(1:jpoce,1:jpksed,jwpo4  ) )
-         
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,10)  , iarroce(1:jpoce), &
-            &                    pwcp(1:jpoce,1:jpksed,jwalk  ) )
-         
-         CALL unpack_arr( jpoce, trcsedi(1:jpi,1:jpj,1:jpksed,11)  , iarroce(1:jpoce), &
-         &                    pwcp(1:jpoce,1:jpksed,jwc13  ) )
-         
-         ! porosity
-         zdta(:,:) = 0.
-         DO jk = 1, jpksed
-            DO ji = 1, jpoce
-               zdta(ji,jk) = -LOG10( hipor(ji,jk) / densSW(ji) )
-            ENDDO
-         ENDDO
-         CALL unpack_arr( jpoce, flxsedi3d(1:jpi,1:jpj,1:jpksed,1)  , iarroce(1:jpoce), &
-            &                   zdta(1:jpoce,1:jpksed)  )
-         
-         CALL unpack_arr( jpoce, flxsedi3d(1:jpi,1:jpj,1:jpksed,2)  , iarroce(1:jpoce), &
-            &                   co3por(1:jpoce,1:jpksed)  )
-      
-         ! prognostic variables
-         ! --------------------
-
-
-         DO jn = 1, jptrased
-            cltra = sedtrcd(jn)
-            CALL restput( numrsw, cltra, jpi, jpj, jpksed, 0, trcsedi(:,:,:,jn) )
-         ENDDO
-
-         DO jn = 1, 2
-            cltra = seddia3d(jn)
-            CALL restput( numrsw, cltra, jpi, jpj, jpksed, 0, flxsedi3d(:,:,:,jn) )
-         ENDDO
-
-
-         CALL restclo( numrsw )
-
-      ENDIF
-
-      DEALLOCATE( zdta )  
+      CALL unpack_arr( jpoce, flxsedi3d(1:jpi,1:jpj,1:jpksed,2)  , iarroce(1:jpoce), &
+      &                   co3por(1:jpoce,1:jpksed)  )
+
+      ! prognostic variables
+      ! --------------------
+
+      DO jn = 1, jptrased
+         cltra = TRIM(sedtrcd(jn))
+         CALL iom_rstput( kt, nitrst, numrsw, TRIM(cltra), trcsedi(:,:,:,jn) )
+      ENDDO
+
+      DO jn = 1, 2
+         cltra = TRIM(seddia3d(jn))
+         CALL iom_rstput( kt, nitrst, numrsw, TRIM(cltra), flxsedi3d(:,:,:,jn) )
+      ENDDO
+
+      CALL unpack_arr( jpoce, zdta2(1:jpi,1:jpj,1:jpksed)  , iarroce(1:jpoce), &
+      &                   db(1:jpoce,1:jpksed)  )
+
+      cltra = "dbioturb"
+      CALL iom_rstput( kt, nitrst, numrsw, TRIM(cltra), zdta2(:,:,:) )
+
+      CALL unpack_arr( jpoce, zdta2(1:jpi,1:jpj,1:jpksed)  , iarroce(1:jpoce), &
+      &                   irrig(1:jpoce,1:jpksed)  )
+
+      cltra = "irrig"
+      CALL iom_rstput( kt, nitrst, numrsw, TRIM(cltra), zdta2(:,:,:) )
+
+      CALL unpack_arr( jpoce, zdta2(1:jpi,1:jpj,1:jpksed)  , iarroce(1:jpoce), &
+      &                   sedligand(1:jpoce,1:jpksed)  )
+
+      cltra = "sedligand"
+      CALL iom_rstput( kt, nitrst, numrsw, TRIM(cltra), zdta2(:,:,:) )
+
+      IF( kt == nitrst ) THEN
+          CALL iom_close( numrsw )     ! close the restart file (only at last time step)
+          IF( l_offline .AND. ln_rst_list ) THEN
+             nrst_lst = nrst_lst + 1
+             nitrst = nstocklist( nrst_lst )
+          ENDIF
+      ENDIF
+
+      IF( ln_timing )  CALL timing_stop('sed_rst_wri')
          
    END SUBROUTINE sed_rst_wri
-#else
-   !!======================================================================
-   !! MODULE sedrst :   Dummy module 
-   !!======================================================================
-   !! $Id$
-CONTAINS
-   SUBROUTINE sed_rst_read                      ! Empty routines
-   END SUBROUTINE sed_rst_read
-   SUBROUTINE sed_rst_wri( kt )
-      INTEGER, INTENT ( in ) :: kt
-      WRITE(*,*) 'sed_rst_wri: You should not have seen this print! error?', kt
-   END SUBROUTINE sed_rst_wri   
-#endif
+
+
+   SUBROUTINE sed_rst_cal( kt, cdrw )
+      !!---------------------------------------------------------------------
+      !!                   ***  ROUTINE sed_rst_cal  ***
+      !!
+      !!  ** Purpose : Read or write calendar in restart file:
+      !!
+      !!  WRITE(READ) mode:
+      !!       kt        : number of time step since the begining of the experiment at the
+      !!                   end of the current(previous) run
+      !!       adatrj(0) : number of elapsed days since the begining of the experiment at the
+      !!                   end of the current(previous) run (REAL -> keep fractions of day)
+      !!       ndastp    : date at the end of the current(previous) run (coded as yyyymmdd integer)
+      !!
+      !!   According to namelist parameter nrstdt,
+      !!       nn_rsttr = 0  no control on the date (nittrc000 is  arbitrary).
+      !!       nn_rsttr = 1  we verify that nittrc000 is equal to the last
+      !!                   time step of previous run + 1.
+      !!       In both those options, the  exact duration of the experiment
+      !!       since the beginning (cumulated duration of all previous restart runs)
+      !!       is not stored in the restart and is assumed to be (nittrc000-1)*rdt.
+      !!       This is valid is the time step has remained constant.
+      !!
+      !!       nn_rsttr = 2  the duration of the experiment in days (adatrj)
+      !!                    has been stored in the restart file.
+      !!----------------------------------------------------------------------
+      INTEGER         , INTENT(in) ::   kt         ! ocean time-step
+      CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
+      !
+      INTEGER  ::  jlibalt = jprstlib
+      LOGICAL  ::  llok
+      REAL(wp) ::  zkt, zrdttrc1
+      REAL(wp) ::  zndastp
+
+      ! Time domain : restart
+      ! ---------------------
+
+      IF( TRIM(cdrw) == 'READ' ) THEN
+
+         IF(lwp) WRITE(numsed,*)
+         IF(lwp) WRITE(numsed,*) 'sed_rst_cal : read the SED restart file for calendar'
+         IF(lwp) WRITE(numsed,*) '~~~~~~~~~~~~'
+
+         IF( ln_rst_sed ) THEN
+            CALL iom_open( TRIM(cn_sedrst_indir)//'/'//cn_sedrst_in, numrsr, kiolib = jlibalt )
+            CALL iom_get ( numrsr, 'kt', zkt )   ! last time-step of previous run
+
+            IF(lwp) THEN
+               WRITE(numsed,*) ' *** Info read in restart : '
+               WRITE(numsed,*) '   previous time-step                               : ', NINT( zkt )
+               WRITE(numsed,*) ' *** restart option'
+               SELECT CASE ( nn_rstsed )
+               CASE ( 0 )   ;   WRITE(numsed,*) ' nn_rstsed = 0 : no control of nittrc000'
+               CASE ( 1 )   ;   WRITE(numsed,*) ' nn_rstsed = 1 : no control the date at nittrc000 (use ndate0 read in the namelist)'
+               CASE ( 2 )   ;   WRITE(numsed,*) ' nn_rstsed = 2 : calendar parameters read in restart'
+               END SELECT
+               WRITE(numsed,*)
+            ENDIF
+            ! Control of date 
+            IF( nittrc000  - NINT( zkt ) /= nn_dtsed .AND.  nn_rstsed /= 0 )                                  &
+               &   CALL ctl_stop( ' ===>>>> : problem with nittrc000 for the restart',                 &
+               &                  ' verify the restart file or rerun with nn_rsttr = 0 (namelist)' )
+         ENDIF
+         !
+         IF( l_offline ) THEN
+            !                                          ! set the date in offline mode
+            IF( ln_rst_sed .AND. nn_rstsed == 2 ) THEN
+               CALL iom_get( numrsr, 'ndastp', zndastp )
+               ndastp = NINT( zndastp )
+               CALL iom_get( numrsr, 'adatrj', adatrj  )
+             ELSE
+               ndastp = ndate0 - 1     ! ndate0 read in the namelist in dom_nam
+               adatrj = ( REAL( nittrc000-1, wp ) * rdt ) / rday
+               ! note this is wrong if time step has changed during run
+            ENDIF
+            !
+            IF(lwp) THEN
+              WRITE(numsed,*) ' *** Info used values : '
+              WRITE(numsed,*) '   date ndastp                                      : ', ndastp
+              WRITE(numsed,*) '   number of elapsed days since the begining of run : ', adatrj
+              WRITE(numsed,*)
+            ENDIF
+            !
+            CALL day_init          ! compute calendar
+            !
+         ENDIF
+         !
+      ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN
+         !
+         IF(  kt == nitrst ) THEN
+            IF(lwp) WRITE(numsed,*)
+            IF(lwp) WRITE(numsed,*) 'trc_wri : write the TOP restart file (NetCDF) at it= ', kt, ' date= ', ndastp
+            IF(lwp) WRITE(numsed,*) '~~~~~~~'
+         ENDIF
+         CALL iom_rstput( kt, nitrst, numrsw, 'kt'     , REAL( kt    , wp) )   ! time-step
+         CALL iom_rstput( kt, nitrst, numrsw, 'ndastp' , REAL( ndastp, wp) )   ! date
+         CALL iom_rstput( kt, nitrst, numrsw, 'adatrj' , adatrj            )   ! number of elapsed days since
+         !                                                                     ! the begining of the run [s]
+      ENDIF
+
+   END SUBROUTINE sed_rst_cal
 
 END MODULE sedrst
Index: /NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/TOP/PISCES/SED/sedsfc.F90
===================================================================
--- /NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/TOP/PISCES/SED/sedsfc.F90	(revision 10344)
+++ /NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/TOP/PISCES/SED/sedsfc.F90	(revision 10345)
@@ -4,5 +4,4 @@
    !!    Sediment : Data at sediment surface
    !!=====================================================================
-#if defined key_sed && ! defined key_sed_off
    !! * Modules used
    USE sed     ! sediment global variable
@@ -32,11 +31,7 @@
 
       !------------------------------------------------------------------------
+      ! reading variables
 
-      IF( kt == nitsed000 ) THEN
-         WRITE(numsed,*) ' sed_sfc : Give data from sediment model to tracer model  '
-         WRITE(numsed,*) ' '
-      ENDIF
-
-      ! reading variables
+      IF( ln_timing )  CALL timing_start('sed_sfc')
 
       CALL unpack_arr ( jpoce, trc_data(1:jpi,1:jpj,1), iarroce(1:jpoce), pwcp(1:jpoce,1,jwalk) )
@@ -46,4 +41,6 @@
       CALL unpack_arr ( jpoce, trc_data(1:jpi,1:jpj,5), iarroce(1:jpoce), pwcp(1:jpoce,1,jwoxy) )
       CALL unpack_arr ( jpoce, trc_data(1:jpi,1:jpj,6), iarroce(1:jpoce), pwcp(1:jpoce,1,jwsil) )
+      CALL unpack_arr ( jpoce, trc_data(1:jpi,1:jpj,7), iarroce(1:jpoce), pwcp(1:jpoce,1,jwnh4) )
+      CALL unpack_arr ( jpoce, trc_data(1:jpi,1:jpj,8), iarroce(1:jpoce), pwcp(1:jpoce,1,jwfe2) )
 
 
@@ -52,27 +49,19 @@
             ikt = mbkt(ji,jj)
             IF ( tmask(ji,jj,ikt) == 1 ) THEN
-               trn(ji,jj,ikt,jptal) = trc_data(ji,jj,1)
-               trn(ji,jj,ikt,jpdic) = trc_data(ji,jj,2)
-               trn(ji,jj,ikt,jpno3) = trc_data(ji,jj,3) * 7.6
-               trn(ji,jj,ikt,jppo4) = trc_data(ji,jj,4) * 122.
-               trn(ji,jj,ikt,jpoxy) = trc_data(ji,jj,5)
-               trn(ji,jj,ikt,jpsil) = trc_data(ji,jj,6)
+               trb(ji,jj,ikt,jptal) = trc_data(ji,jj,1)
+               trb(ji,jj,ikt,jpdic) = trc_data(ji,jj,2)
+               trb(ji,jj,ikt,jpno3) = trc_data(ji,jj,3) * 7.625
+               trb(ji,jj,ikt,jppo4) = trc_data(ji,jj,4) * 122.
+               trb(ji,jj,ikt,jpoxy) = trc_data(ji,jj,5)
+               trb(ji,jj,ikt,jpsil) = trc_data(ji,jj,6)
+               trb(ji,jj,ikt,jpnh4) = trc_data(ji,jj,7) * 7.625
+               trb(ji,jj,ikt,jpfer) = trc_data(ji,jj,8)
             ENDIF
          ENDDO
       ENDDO
 
+      IF( ln_timing )  CALL timing_stop('sed_sfc')
+
    END SUBROUTINE sed_sfc
 
-#else
-   !!======================================================================
-   !! MODULE sedsfc  :   Dummy module 
-   !!======================================================================
-   !! $Id$
-CONTAINS
-   SUBROUTINE sed_sfc ( kt )
-      INTEGER, INTENT(in) :: kt
-      WRITE(*,*) 'sed_sfc: You should not have seen this print! error?', kt
-   END SUBROUTINE sed_sfc
-#endif
-
 END MODULE sedsfc
Index: /NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/TOP/PISCES/SED/sedstp.F90
===================================================================
--- /NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/TOP/PISCES/SED/sedstp.F90	(revision 10344)
+++ /NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/src/TOP/PISCES/SED/sedstp.F90	(revision 10345)
@@ -1,4 +1,3 @@
 MODULE sedstp
-#if defined key_sed
    !!======================================================================
    !!                       ***  MODULE sedstp   ***
@@ -9,5 +8,6 @@
    USE sedchem  ! chemical constant
    USE sedco3   ! carbonate in sediment pore water
-   USE seddsr   ! dissolution reaction
+   USE sedorg   ! Organic reactions and diffusion
+   USE sedinorg ! Inorganic dissolution
    USE sedbtb   ! bioturbation
    USE sedadv   ! vertical advection
@@ -16,4 +16,7 @@
    USE sedrst   ! restart
    USE sedwri   ! outputs
+   USE trcdmp_sed
+   USE lib_mpp         ! distribued memory computing library
+   USE iom
 
    IMPLICIT NONE
@@ -42,38 +45,53 @@
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt       ! number of iteration
+      INTEGER :: ji,jk,js,jn,jw
+      !!----------------------------------------------------------------------
+      IF( ln_timing )      CALL timing_start('sed_stp')
+        !
+                                CALL sed_rst_opn  ( kt )       ! Open tracer restart file 
+      IF( lrst_sed )            CALL sed_rst_cal  ( kt, 'WRITE' )   ! calenda
 
-      !!----------------------------------------------------------------------
+      IF(ln_sediment_offline)   CALL trc_dmp_sed  ( kt )
 
-      IF( kt /= nitsed000 )  THEN
-        CALL sed_dta( kt )       ! Load  Data for bot. wat. Chem and fluxes
-        CALL sed_chem( kt )      ! update of chemical constant to account for salinity, temperature changes
+      dtsed  = r2dttrc
+!      dtsed2 = dtsed
+      IF (kt /= nitsed000) THEN
+         CALL sed_dta( kt )       ! Load  Data for bot. wat. Chem and fluxes
       ENDIF
-      CALL sed_dsr( kt )         ! Dissolution reaction
-      CALL sed_adv( kt )         ! advection
-      CALL sed_btb( kt )         ! Bioturbation
 
-      IF ( ( MOD( kt, nwrised ) == 0 ) .OR. ( MOD( kt, nstock ) == 0 ) .OR. ( kt == nitsedend )  )   &
-      CALL sed_co3( kt )         ! pH actualization for saving
-      CALL sed_mbc( kt )         ! cumulation for mass balance calculation
-#if ! defined key_sed_off
-      CALL sed_sfc( kt )         ! Give back new bottom wat chem to tracer model
-#endif
-      CALL sed_rst_wri( kt )   ! restart file output
+      IF (sedmask == 1. ) THEN
+         IF( kt /= nitsed000 )  THEN
+           CALL sed_chem( kt )      ! update of chemical constant to account for salinity, temperature changes
+         ENDIF
+
+         CALL sed_btb( kt )         ! 1st pass of bioturbation at t+1/2
+         CALL sed_org( kt )         ! Organic related reactions and diffusion
+         CALL sed_inorg( kt )       ! Dissolution reaction
+         CALL sed_btb( kt )         ! 2nd pass of bioturbation at t+1
+         tokbot(:,:) = 0.0
+         DO jw = 1, jpwat
+            DO ji = 1, jpoce
+               tokbot(ji,jw) = pwcp(ji,1,jw) * 1.e-3 * dzkbot(ji)
+            END DO
+         ENDDO
+         CALL sed_adv( kt )         ! advection
+         CALL sed_co3( kt )         ! pH actualization for saving
+         ! This routine is commented out since it does not work at all
+         CALL sed_mbc( kt )         ! cumulation for mass balance calculation
+
+         IF (ln_sed_2way) CALL sed_sfc( kt )         ! Give back new bottom wat chem to tracer model
+      ENDIF
       CALL sed_wri( kt )         ! outputs
+      IF( kt == nitsed000 ) THEN
+          CALL iom_close( numrsr )       ! close input tracer restart file
+!          IF(lwm) CALL FLUSH( numont )   ! flush namelist output
+      ENDIF
+      IF( lrst_sed )            CALL sed_rst_wri( kt )   ! restart file output
 
       IF( kt == nitsedend )  CLOSE( numsed )
 
+      IF( ln_timing )   CALL timing_stop('sed_stp')
+
    END SUBROUTINE sed_stp
 
-#else
-   !!======================================================================
-   !! MODULE sedstp  :   Dummy module 
-   !!======================================================================
-   !! $Id$
-CONTAINS
-   SUBROUTINE sed_stp( kt )         ! Empty routine
-      INTEGER, INTENT(in) :: kt
-      WRITE(*,*) 'sed_stp: You should not have seen this print! error?', kt
-   END SUBROUTINE sed_stp
-#endif
 END MODULE sedstp
